/************************************************************************

  A function to convert IEEE double numbers to VAX double numbers and
  vice versa
  and convert IEEE double numbers to SUN double numbers and vice versa

*************************************************************************/

#include <stdio.h>
#include <math.h>

void
convert_double(c, type)
    unsigned char   c[8];	/* the double number                    */
    long            type;	/* the type of conversion 1 = IEEE to VAX 2 =
				 * VAX to IEEE 3 = IEEE to SUN 4 = SUN to
				 * IEEE 5 = SUN to VAX 6 = VAX to SUN 7 =
				 * IEEE to MAC 8 = MAC to IEEE                      */

{
    int             i;
    unsigned long   exp;
    struct
    {				/* the double number               */
	unsigned int    sgn:1;
	unsigned int    exp1:7;
	unsigned int    exp2:4;
	unsigned int    mant1:4;
	unsigned int    mant2:16;
	unsigned int    mant3:16;
	unsigned int    mant4:16;
    }               IEEE_dbl;

    /*
     * struct                      * the VAX double number                * {
     * unsigned int sgn:1; unsigned int exp1:7; unsigned int exp2:1; unsigned
     * int mant1:7; unsigned int mant2:16; unsigned int mant3:16; unsigned
     * int mant4:16; } VAX_dbl;
     */

    /*
     * struct                      * the MAC double number                * {
     * unsigned int sgn:1; unsigned int exp1:7; unsigned int exp2:1; unsigned
     * int exp3:7; unsigned int mant1:16; unsigned int mant2:16; unsigned int
     * mant3:16; unsigned int mant4:16; unsigned int mant5:16; } MAC_dbl;
     */
    union
    {				/* the short & character union          */
	unsigned short  s;
	unsigned char   c[2];
    }               shtchr;
    unsigned char   tc;		/* the temp character value             */

    /* Reverse bytes if IEEE */

    if (type == 1 || type == 3)
	for (i = 0; i < 4; i++)
	{
	    tc = c[i];
	    c[i] = c[7 - i];
	    c[7 - i] = tc;
	}

    /*
     * If from VAX switch bytes, put into switch union, add to the exponent,
     * and put into swithc union
     */

    if (type == 2 || type == 6)
    {

	for (i = 0; i < 4; i++)
	{
	    tc = c[i * 2];
	    c[i * 2] = c[i * 2 + 1];
	    c[i * 2 + 1] = tc;
	}

	IEEE_dbl.sgn = (c[0] >> 7) & 1;
	exp = ((c[0] & 127) << 1) + ((c[1] >> 7) & 1) + 1023 - 129;
	printf("exp = %ld\n", exp);
	IEEE_dbl.exp1 = (exp >> 4) & 127;
	IEEE_dbl.exp2 = exp & 15;
	IEEE_dbl.mant1 = ((c[1] & 127) >> 3) & 15;
	IEEE_dbl.mant2 = ((c[1] & 7) << 13) + (c[2] << 5)
		  + ((c[3] >> 3) & 31);
	IEEE_dbl.mant3 = ((c[3] & 7) << 13) + (c[4] << 5)
		  + ((c[5] >> 3) & 31);
	IEEE_dbl.mant4 = ((c[5] & 7) << 13) + (c[6] << 5)
		  + ((c[7] >> 3) & 31);

	c[0] = (IEEE_dbl.sgn << 7) + IEEE_dbl.exp1;
	c[1] = (IEEE_dbl.exp2 << 4) + IEEE_dbl.mant1;
	shtchr.s = IEEE_dbl.mant2;
	c[2] = shtchr.c[1];
	c[3] = shtchr.c[0];
	shtchr.s = IEEE_dbl.mant3;
	c[4] = shtchr.c[1];
	c[5] = shtchr.c[0];
	shtchr.s = IEEE_dbl.mant4;
	c[6] = shtchr.c[1];
	c[7] = shtchr.c[0];

    }

    /*
     * If to VAX put in switch union, subtract from the exponent, put into
     * switch union, and switch bytes
     */

    if (type == 1 || type == 5)
    {

	/*
	 * for (i=0; i<8; i++) IEEEdbl.c[i] = c[i];
	 * 
	 * IEEEdbl.d.exp -= 1023 - 129;
	 * 
	 * VAXdbl.d.sgn = IEEEdbl.d.sgn; VAXdbl.d.exp = IEEEdbl.d.exp;
	 * VAXdbl.d.mant1 = IEEEdbl.d.mant1; VAXdbl.d.mant2 =
	 * IEEEdbl.d.mant2; VAXdbl.d.mant3 = IEEEdbl.d.mant3; VAXdbl.d.mant4
	 * = IEEEdbl.d.mant4; VAXdbl.d.mant5 = 0;
	 * 
	 * for (i=0; i<8; i++) c[i] = VAXdbl.c[i]; for (i=0; i<4; i++) { tc =
	 * c[i*2]; c[i*2] = c[i*2+1]; c[i*2+1] = tc; }
	 */
    }
    /* Reverse bytes if to VAX to IEEE */

    if (type == 2 || type == 4)
	for (i = 0; i < 4; i++)
	{
	    tc = c[i];
	    c[i] = c[7 - i];
	    c[7 - i] = tc;
	}

}
